#!/usr/bin/python

from StringIO import StringIO

def read_uintn(f, n):
    r = 0L
    for c in f.read(n):
        r = (r << 8) | ord(c)
    return r

def read_uint16(f):
    return read_uintn(f, 2)

def read_uint32(f):
    return read_uintn(f, 4)

def read_uint64(f):
    return read_uintn(f, 8)


# standard cdb entry format:
# UINT16    type
# BYTE      loflag
# if loflag == ">":
#   UINT16  lo
# UINT32    ttl
# UINT64    timestamp  (TIA64)
# VAR       rdata
def parse_entry(s):
    f = StringIO(s)
    type = read_uint16(f)
    loflag = f.read(1)
    if loflag == ">":
        lo = f.read(2)
    elif loflag == "=":
        lo = None
    else:
        raise ValueError, "unknown value in data file"
    ttl = read_uint32(f)
    timestamp = read_uint64(f)
    rdata = f.read()
    return (type, loflag, lo, ttl, timestamp, len(rdata), rdata)
